<?php 
function callPluginFunction($args){
	$name='PLUGIN'.$args[1];			// name on the plugin function
	$params=explode(',',$args[2]);		// parameters of the plugin function
	return $name($params);				// call the plugin function
}

function callSystemFunction($args){
	$idx=$args[1]+0;
	$key=$args[2];
	switch($idx){
		case -1: 
			return getField($key); 				// [[-1:key]]
			break;
		case -2:
			list($key,$ind)=explode(',',$key);	// [[-2:key,ind]]
			return getField($key,$ind);
			break;
		default: 								// [[0:key]]
			return getVal($idx,$key);
	}
}
	
function getReg($txt){
	$txt = preg_replace_callback('`\[\[([0-9-]+):([a-z0-9,_]+)\]\]`i','callSystemFunction',$txt);
	return preg_replace_callback('`#PLUGIN([a-z0-9]+)\(([a-z0-9 ,._]+)\)`i','callPluginFunction',$txt);
}

function setReq($whr,$ord,$typ){
	global $DTA, $IDX;
  	$DTA[99]['WHR']=$whr;
  	$DTA[99]['ORD']=$ord;
  	$DTA[99]['TYP']=$typ;
  	$IDX=99;
}

function getLink($txt,$lnk,$ttl='---'){
	return "<a href='index.php?$lnk' title='$ttl'>$txt</a>";
}

function getVal($idx,$key){	// get the value or the parent's value
	global $DTA;				
	return isset($DTA[$idx][$key])?$DTA[$idx][$key]:getVal($DTA[$idx]['XTD'],$key);
}

function getField($key,$ind=''){		// get the value of the current record/idx
	global $IDX;
	$val=getVal($IDX,$key);
	return $ind==''?$val:getVal($val+0,$ind);		// direct / indirect
}

function getData($nam){		// load data from file
	global $DTA,$IDX,$TPL;
	//
	$fil=file($nam);
	$idx=0;
	$ok=false;
	foreach($fil as $lig){
		$lig=str_replace(chr(10),'',$lig);
		$lig=str_replace(chr(13),'',$lig);
		if($lig=='---0')   $ok=true;			// begin parse
		if($lig=='---999') $ok=false;			// end parse
		if(!$ok) continue;						// no parse --> next line
		if(substr($lig,0,3)=='---'){			// new record?
			$idx=substr($lig,3)+0;				// new idx (must be a number)
		}else{
			list($key,$val)=explode(':',$lig,2);// key:value...
			$DTA[$idx][$key]=$val;				// new field
		}
	}
	$TPL=getVal(0,'TPL');						// current template
	//
	$dir=opendir('plugins');
	while($file=readdir($dir)){
		if($file!='.' && $file!='..') include_once("plugins/$file/index.php");
	}
	closedir($dir);
}

function showContent(){
	global $TPL,$DTA,$IDX,$IDXARR;
	// single
	if($IDX>=100)
		include("templates/$TPL/single".getVal($IDX,'TYP').'.php');	// show record and fields
	// list
	else if($IDX>=10){									// command
		$typ=getVal($IDX,'TYP');						// type
		$cmd='$res=('.getVal($IDX,'WHR').');';			// Where command
		$ord=getVal($IDX,'ORD');						// Order by : +abc -abc
		$dir=substr($ord,0,1);							// + -
		$ord=substr($ord,1);							// abc
		foreach($DTA as $key=>$val)						// search
			if($key>=100){								// is a record?
				$IDX=$key+0;							// current idx
				eval($cmd);								// eval criteria
				if($res) $arr[$IDX]=getVal($IDX,$ord);	// if res==true then add this index/value
			}
		switch($dir){									// order by asc/desc
			case '+':asort($arr); break;				// asc
			case '-':arsort($arr); break;				// desc
		}
		$IDXARR=$arr;									// global array of indexes
		include("templates/$TPL/list$typ.php");			// include the list template
	}
}

//-------------------------

	getData('data.txt');
	$IDX=$_SERVER['QUERY_STRING']!=''?$_SERVER['QUERY_STRING']+0:getVal(0,'IDX')+0;
	$IDX=$IDX==0?getVal(0,'IDX')+0:$IDX;
	$IDXARR=0;
	include("templates/$TPL/page.php");
?>